/**
 * Bundle of @devexpress/dx-vue-grid-bootstrap4
 * Generated: 2018-05-24
 * Version: 1.3.0-beta.2
 * License: https://js.devexpress.com/Licensing
 */

import { DxGrid, DxGroupingPanel, DxPagingPanel, DxSearchPanel, DxTable, DxTableEditColumn, DxTableEditRow, DxTableFilterRow, DxTableGroupRow, DxTableHeaderRow, DxTableRowDetail, DxTableSelection, DxToolbar, GroupPanelLayout, StaticTableLayout, TableLayout } from '@devexpress/dx-vue-grid';
import { calculateStartPage, firstRowOnPage, lastRowOnPage } from '@devexpress/dx-grid-core';

var nestRE = /^(attrs|props|on|nativeOn|class|style|hook)$/;

var babelHelperVueJsxMergeProps = function mergeJSXProps(objs) {
  return objs.reduce(function (a, b) {
    var aa, bb, key, nestedKey, temp;
    for (key in b) {
      aa = a[key];
      bb = b[key];
      if (aa && nestRE.test(key)) {
        // normalize class
        if (key === 'class') {
          if (typeof aa === 'string') {
            temp = aa;
            a[key] = aa = {};
            aa[temp] = true;
          }
          if (typeof bb === 'string') {
            temp = bb;
            b[key] = bb = {};
            bb[temp] = true;
          }
        }
        if (key === 'on' || key === 'nativeOn' || key === 'hook') {
          // merge functions
          for (nestedKey in bb) {
            aa[nestedKey] = mergeFn(aa[nestedKey], bb[nestedKey]);
          }
        } else if (Array.isArray(aa)) {
          a[key] = aa.concat(bb);
        } else if (Array.isArray(bb)) {
          a[key] = [aa].concat(bb);
        } else {
          for (nestedKey in bb) {
            aa[nestedKey] = bb[nestedKey];
          }
        }
      } else {
        a[key] = b[key];
      }
    }
    return a;
  }, {});
};

function mergeFn(a, b) {
  return function () {
    a && a.apply(this, arguments);
    b && b.apply(this, arguments);
  };
}

var GridRoot = {
  render: function render() {
    var h = arguments[0];

    return h("div", [this.$slots.default]);
  }
};

var DxGrid$1 = {
  name: 'DxGrid',
  functional: true,
  render: function render(h, context) {
    return h(
      DxGrid,
      babelHelperVueJsxMergeProps([{
        attrs: {
          rootComponent: GridRoot
        }
      }, { attrs: context.props, on: context.listeners }]),
      [context.children]
    );
  },

  components: {
    DxRoot: GridRoot
  }
};

var MINIMAL_COLUMN_WIDTH = 150;

var TableLayout$1 = {
  render: function render() {
    var h = arguments[0];

    return h(TableLayout, babelHelperVueJsxMergeProps([{ attrs: this.$attrs }, {
      attrs: {
        layoutComponent: StaticTableLayout,
        minColumnWidth: MINIMAL_COLUMN_WIDTH
      }
    }]));
  }
};

var TableContainer = {
  render: function render() {
    var h = arguments[0];

    return h(
      "div",
      { "class": "table-responsive" },
      [this.$slots.default]
    );
  }
};

var Table = {
  render: function render() {
    var h = arguments[0];

    return h(
      "table",
      babelHelperVueJsxMergeProps([{
        "class": "table mb-0 w-100 dx-g-bs4-overflow-hidden dx-g-bs4-table"
      }, { attrs: this.$attrs, on: this.$listeners }]),
      [this.$slots.default]
    );
  }
};

var TableHead = {
  render: function render() {
    var h = arguments[0];

    return h(
      "thead",
      { attrs: this.$attrs, on: this.$listeners },
      [this.$slots.default]
    );
  }
};

var TableBody = {
  render: function render() {
    var h = arguments[0];

    return h(
      "tbody",
      { attrs: this.$attrs, on: this.$listeners },
      [this.$slots.default]
    );
  }
};

var TableRow = {
  props: {
    row: null,
    tableRow: {
      type: Object
    },
    tableColumn: {
      type: Object
    }
  },
  render: function render() {
    var h = arguments[0];

    return h(
      "tr",
      { attrs: this.$attrs, on: this.$listeners },
      [this.$slots.default]
    );
  }
};

var asyncGenerator = function () {
  function AwaitValue(value) {
    this.value = value;
  }

  function AsyncGenerator(gen) {
    var front, back;

    function send(key, arg) {
      return new Promise(function (resolve, reject) {
        var request = {
          key: key,
          arg: arg,
          resolve: resolve,
          reject: reject,
          next: null
        };

        if (back) {
          back = back.next = request;
        } else {
          front = back = request;
          resume(key, arg);
        }
      });
    }

    function resume(key, arg) {
      try {
        var result = gen[key](arg);
        var value = result.value;

        if (value instanceof AwaitValue) {
          Promise.resolve(value.value).then(function (arg) {
            resume("next", arg);
          }, function (arg) {
            resume("throw", arg);
          });
        } else {
          settle(result.done ? "return" : "normal", result.value);
        }
      } catch (err) {
        settle("throw", err);
      }
    }

    function settle(type, value) {
      switch (type) {
        case "return":
          front.resolve({
            value: value,
            done: true
          });
          break;

        case "throw":
          front.reject(value);
          break;

        default:
          front.resolve({
            value: value,
            done: false
          });
          break;
      }

      front = front.next;

      if (front) {
        resume(front.key, front.arg);
      } else {
        back = null;
      }
    }

    this._invoke = send;

    if (typeof gen.return !== "function") {
      this.return = undefined;
    }
  }

  if (typeof Symbol === "function" && Symbol.asyncIterator) {
    AsyncGenerator.prototype[Symbol.asyncIterator] = function () {
      return this;
    };
  }

  AsyncGenerator.prototype.next = function (arg) {
    return this._invoke("next", arg);
  };

  AsyncGenerator.prototype.throw = function (arg) {
    return this._invoke("throw", arg);
  };

  AsyncGenerator.prototype.return = function (arg) {
    return this._invoke("return", arg);
  };

  return {
    wrap: function (fn) {
      return function () {
        return new AsyncGenerator(fn.apply(this, arguments));
      };
    },
    await: function (value) {
      return new AwaitValue(value);
    }
  };
}();













var defineProperty = function (obj, key, value) {
  if (key in obj) {
    Object.defineProperty(obj, key, {
      value: value,
      enumerable: true,
      configurable: true,
      writable: true
    });
  } else {
    obj[key] = value;
  }

  return obj;
};

var _extends = Object.assign || function (target) {
  for (var i = 1; i < arguments.length; i++) {
    var source = arguments[i];

    for (var key in source) {
      if (Object.prototype.hasOwnProperty.call(source, key)) {
        target[key] = source[key];
      }
    }
  }

  return target;
};

var TableCell = {
  props: {
    row: null,
    tableRow: {
      type: Object
    },
    column: {
      type: Object
    },
    tableColumn: {
      type: Object
    },
    value: null
  },
  render: function render() {
    var h = arguments[0];

    var align = this.tableColumn && this.tableColumn.align || 'left';
    return h(
      'td',
      babelHelperVueJsxMergeProps([{
        'class': defineProperty({
          'dx-g-bs4-table-cell': true,
          'text-nowrap': !(this.tableColumn && this.tableColumn.wordWrapEnabled)
        }, 'text-' + align, align !== 'left')
      }, { attrs: this.$attrs, on: this.$listeners }]),
      [this.$slots.default || this.value]
    );
  }
};

var TableNoDataCell = {
  props: {
    tableRow: {
      type: Object
    },
    tableColumn: {
      type: Object
    },
    getMessage: {
      type: Function,
      required: true
    }
  },
  render: function render() {
    var h = arguments[0];

    return h(
      "td",
      babelHelperVueJsxMergeProps([{
        "class": "py-5 text-center"
      }, { attrs: this.$attrs, on: this.$listeners }]),
      [h(
        "big",
        {
          attrs: { className: "text-muted" }
        },
        [this.getMessage('noData')]
      )]
    );
  }
};

var TableStubRow = {
  props: {
    tableRow: {
      type: Object
    }
  },
  render: function render() {
    var h = arguments[0];

    return h("tr", [this.$slots.default]);
  }
};

var TableHeaderStubCell = {
  props: {
    tableRow: {
      type: Object
    },
    tableColumn: {
      type: Object
    }
  },
  render: function render() {
    var h = arguments[0];

    return h("th", {
      "class": "py-0"
    });
  }
};

var TableStubCell = {
  props: {
    tableRow: {
      type: Object
    },
    tableColumn: {
      type: Object
    }
  },
  render: function render() {
    var h = arguments[0];

    return h("td", {
      "class": "py-0"
    });
  }
};

var defaultMessages = {
  noData: 'No data'
};

var DxTable$1 = {
  name: 'DxTable',
  functional: true,
  render: function render(h, context) {
    return h(DxTable, babelHelperVueJsxMergeProps([{
      attrs: {
        layoutComponent: TableLayout$1,
        containerComponent: TableContainer,
        tableComponent: Table,
        headComponent: TableHead,
        bodyComponent: TableBody,
        rowComponent: TableRow,
        cellComponent: TableCell,
        noDataCellComponent: TableNoDataCell,
        noDataRowComponent: TableRow,
        stubRowComponent: TableStubRow,
        stubCellComponent: TableStubCell,
        stubHeaderCellComponent: TableHeaderStubCell,
        messages: _extends({}, defaultMessages, context.props.messages)
      }
    }, { attrs: context.props, on: context.listeners }]));
  },

  components: {
    DxContainer: TableContainer,
    DxTable: Table,
    DxTableHead: TableHead,
    DxTableBody: TableBody,
    DxRow: TableRow,
    DxCell: TableCell,
    DxNoDataCell: TableNoDataCell,
    DxNoDataRow: TableRow,
    DxStubCell: TableStubCell,
    DxStubHeaderCell: TableHeaderStubCell,
    DxStubRow: TableStubRow
  }
};

var SortingIndicator = {
  props: {
    direction: {
      type: String,
      default: null
    },
    disabled: {
      type: Boolean
    }
  },
  render: function render() {
    var h = arguments[0];
    var direction = this.direction;

    var classes = {
      'oi dx-g-bs4-sorting-indicator mx-2': true,
      'oi-arrow-thick-bottom': direction === 'desc',
      'oi-arrow-thick-top': direction !== 'desc',
      invisible: !direction
    };
    return h('span', {
      'class': classes
    });
  }
};

var ENTER_KEY_CODE = 13;
var SPACE_KEY_CODE = 32;

var SortingControl = {
  props: {
    align: {
      type: String,
      required: true
    },
    direction: {
      type: String,
      default: null
    },
    disabled: {
      type: Boolean
    }
  },
  methods: {
    handleMouseDown: function handleMouseDown(e) {
      e.currentTarget.style.outline = 'none';
    },
    handleBlur: function handleBlur(e) {
      e.currentTarget.style.outline = '';
    },
    handleClick: function handleClick(e) {
      this.emitChange(e);
    },
    handleKeyDown: function handleKeyDown(e) {
      var isActionKeyDown = e.keyCode === ENTER_KEY_CODE || e.keyCode === SPACE_KEY_CODE;
      if (!isActionKeyDown) return;

      this.emitChange(e);
    },
    emitChange: function emitChange(e) {
      if (this.disabled) return;

      var cancelSortingRelatedKey = e.metaKey || e.ctrlKey;
      var direction = cancelSortingRelatedKey ? null : undefined;

      e.preventDefault();
      this.$emit('change', {
        direction: direction,
        keepOther: e.shiftKey || cancelSortingRelatedKey
      });
    }
  },
  render: function render() {
    var h = arguments[0];

    return h(
      'span',
      {
        'class': {
          'd-inline-flex flex-direction-row align-items-center mw-100': true,
          'dx-g-bs4-cursor-pointer': !this.disabled,
          'flex-row-reverse': this.align === 'right',
          'text-primary': this.direction
        },
        on: {
          'click': this.handleClick,
          'keydown': this.handleKeyDown,
          'blur': this.handleBlur,
          'mousedown': this.handleMouseDown
        },
        attrs: {
          tabIndex: this.disabled ? -1 : 0
        }
      },
      [h(
        'span',
        {
          'class': 'dx-g-bs4-sorting-control-text text-nowrap'
        },
        [this.$slots.default]
      ), this.direction && h(SortingIndicator, {
        attrs: {
          direction: this.direction
        }
      })]
    );
  }
};

var GroupingControl = {
  props: {
    align: {
      type: String,
      required: true
    },
    disabled: {
      type: Boolean
    }
  },
  render: function render() {
    var _this = this;

    var h = arguments[0];
    var align = this.align,
        disabled = this.disabled;

    var invertedAlign = align === 'left';

    return h(
      'div',
      {
        'class': {
          'dx-g-bs4-grouping-control': true,
          'float-right text-right': invertedAlign,
          'float-left text-left': !invertedAlign
        },
        on: {
          'click': function click(e) {
            if (disabled) return;
            e.stopPropagation();
            _this.$emit('group');
          }
        }
      },
      [h('span', {
        'class': {
          'oi oi-list dx-g-bs4-grouping-control-icon': true,
          'dx-g-bs4-cursor-pointer': !disabled,
          'dx-g-bs4-inactive': disabled
        }
      })]
    );
  }
};

var TableHeaderCell = {
  props: {
    tableRow: {
      type: Object
    },
    column: {
      type: Object
    },
    tableColumn: {
      type: Object
    },
    sortingDirection: {
      type: String
    },
    showSortingControls: {
      type: Boolean,
      default: false
    },
    showGroupingControls: {
      type: Boolean,
      default: false
    },
    sortingEnabled: {
      type: Boolean,
      default: false
    },
    groupingEnabled: {
      type: Boolean,
      default: false
    }
  },
  render: function render() {
    var h = arguments[0];
    var tableColumn = this.tableColumn,
        column = this.column,
        showSortingControls = this.showSortingControls,
        showGroupingControls = this.showGroupingControls,
        sortingEnabled = this.sortingEnabled,
        groupingEnabled = this.groupingEnabled,
        sortingDirection = this.sortingDirection;

    var isCellInteractive = showSortingControls && sortingEnabled;
    var align = tableColumn && tableColumn.align || 'left';
    var columnTitle = column && (column.title || column.name);
    return h(
      'th',
      {
        'class': {
          'position-relative dx-g-bs4-header-cell': true,
          'dx-g-bs4-user-select-none': isCellInteractive
        }
      },
      [h(
        'div',
        {
          'class': 'd-flex flex-direction-row align-items-center'
        },
        [h(
          'div',
          {
            'class': defineProperty({
              'dx-g-bs4-table-header-cell-wrapper': true,
              'text-nowrap': !(tableColumn && tableColumn.wordWrapEnabled)
            }, 'text-' + align, align !== 'left')
          },
          [showSortingControls ? h(
            SortingControl,
            {
              attrs: {
                align: align,
                disabled: !sortingEnabled,
                direction: sortingDirection
              },
              on: {
                'change': this.$emit.bind(this, 'sort')
              }
            },
            [columnTitle]
          ) : columnTitle]
        ), showGroupingControls && h('div', [h(GroupingControl, {
          attrs: {
            align: align,
            disabled: !groupingEnabled
          },
          on: {
            'group': this.$emit.bind(this, 'group')
          }
        })])]
      )]
    );
  }
};

var DxTableHeaderRow$1 = {
  name: 'DxTableHeaderRow',
  functional: true,
  render: function render(h, context) {
    return h(DxTableHeaderRow, babelHelperVueJsxMergeProps([{
      attrs: {
        cellComponent: TableHeaderCell,
        rowComponent: TableRow
      }
    }, { attrs: context.props, on: context.listeners }]));
  },

  components: {
    DxCell: TableHeaderCell,
    DxRow: TableRow
  }
};

var TableFilterCell = {
  props: {
    column: {
      type: Object
    },
    tableRow: {
      type: Object
    },
    tableColumn: {
      type: Object
    },
    getMessage: {
      type: Function
    },
    filter: {
      type: Object,
      default: null
    },
    filteringEnabled: {
      type: Boolean,
      default: true
    }
  },
  render: function render() {
    var _this = this;

    var h = arguments[0];
    var filter = this.filter,
        filteringEnabled = this.filteringEnabled;

    return h(
      "th",
      this.$attrs,
      [this.$slots.default || h("input", {
        attrs: {
          type: "text",

          readonly: !filteringEnabled
        },
        "class": "form-control",
        domProps: {
          "value": filter ? filter.value : ''
        },
        on: {
          "input": function input(e) {
            return _this.$emit('filter', e.target.value ? { value: e.target.value } : null);
          }
        }
      })]
    );
  }
};

var DxTableFilterRow$1 = {
  name: 'DxTableFilterRow',
  functional: true,
  render: function render(h, context) {
    return h(DxTableFilterRow, babelHelperVueJsxMergeProps([{
      attrs: {
        cellComponent: TableFilterCell,
        rowComponent: TableRow
      }
    }, { attrs: context.props, on: context.listeners }]));
  },

  components: {
    DxCell: TableFilterCell,
    DxRow: TableRow
  }
};

var DxToolbar$2 = {
  render: function render() {
    var h = arguments[0];

    return h(
      "div",
      {
        "class": "card-header py-2 d-flex position-relative dx-g-bs4-toolbar"
      },
      [this.$slots.default]
    );
  }
};

var FlexibleSpace = {
  render: function render() {
    var h = arguments[0];

    return h("div", { "class": "d-flex ml-auto" });
  }
};

var DxToolbar$1 = {
  render: function render() {
    var h = arguments[0];

    return h(DxToolbar, babelHelperVueJsxMergeProps([{
      attrs: {
        rootComponent: DxToolbar$2,
        flexibleSpaceComponent: FlexibleSpace
      }
    }, this.props]));
  },

  components: {
    DxRoot: DxToolbar$2
  }
};

var GroupPanelContainer = {
  render: function render() {
    var h = arguments[0];

    return h(
      "div",
      {
        "class": "w-100 mt-1"
      },
      [this.$slots.default]
    );
  }
};

var ENTER_KEY_CODE$1 = 13;
var SPACE_KEY_CODE$1 = 32;

var isActionKey = function isActionKey(keyCode) {
  return keyCode === ENTER_KEY_CODE$1 || keyCode === SPACE_KEY_CODE$1;
};

var GroupPanelItem = {
  props: {
    item: {
      type: Object,
      required: true
    },
    showSortingControls: {
      type: Boolean
    },
    sortingDirection: {
      type: String
    },
    showGroupingControls: {
      type: Boolean
    },
    groupingEnabled: {
      type: Boolean
    },
    sortingEnabled: {
      type: Boolean
    }
  },
  render: function render() {
    var _this = this;

    var h = arguments[0];
    var showSortingControls = this.showSortingControls,
        showGroupingControls = this.showGroupingControls,
        sortingEnabled = this.sortingEnabled,
        groupingEnabled = this.groupingEnabled,
        column = this.item.column,
        sortingDirection = this.sortingDirection;

    var handleSortingChange = function handleSortingChange(e) {
      var isActionKeyDown = isActionKey(e.keyCode);
      var isMouseClick = e.keyCode === undefined;
      if (!showSortingControls || !sortingEnabled || !(isActionKeyDown || isMouseClick)) return;

      var cancelSortingRelatedKey = e.metaKey || e.ctrlKey;
      var direction = (isMouseClick || isActionKeyDown) && cancelSortingRelatedKey ? null : undefined;

      e.preventDefault();
      _this.$emit('sort', {
        direction: direction,
        keepOther: cancelSortingRelatedKey
      });
    };
    var handleUngroup = function handleUngroup(e) {
      if (!groupingEnabled) return;
      var isActionKeyDown = isActionKey(e.keyCode);
      var isMouseClick = e.keyCode === undefined;

      if (!isActionKeyDown && !isMouseClick) return;
      _this.$emit('group');
    };
    return h(
      'div',
      {
        'class': {
          'btn-group mb-1 mr-1': true
        }
      },
      [h(
        'span',
        babelHelperVueJsxMergeProps([{
          'class': {
            'btn btn-outline-secondary': true,
            disabled: !sortingEnabled && (showSortingControls || !groupingEnabled)
          },
          on: {
            'click': handleSortingChange,
            'keydown': handleSortingChange
          }
        }, sortingEnabled ? { tabIndex: 0 } : null]),
        [column.title || column.name, showSortingControls && sortingDirection && h('span', ['\xA0', h(SortingIndicator, {
          attrs: {
            direction: sortingDirection
          }
        })])]
      ), showGroupingControls && h(
        'span',
        {
          'class': {
            'btn btn-outline-secondary': true,
            disabled: !groupingEnabled
          },
          on: {
            'click': handleUngroup
          }
        },
        ['\xA0', h('span', {
          'class': 'oi oi-x dx-g-bs4-group-panel-item-icon'
        })]
      )]
    );
  }
};

var GroupPanelEmptyMessage = {
  props: {
    getMessage: {
      type: Function,
      required: true
    }
  },
  render: function render() {
    var h = arguments[0];

    return h(
      "div",
      {
        "class": "dx-g-bs4-group-panel-empty-message"
      },
      [this.getMessage('groupByColumn') || h("span", ["Click the ", h("span", { "class": "oi oi-list dx-g-bs4-grouping-control-icon" }), " icon in the column header to group by that column"])]
    );
  }
};

var defaultMessages$1 = {
  groupByColumn: ''
};

var DxGroupingPanel$1 = {
  name: 'DxGroupingPanel',
  functional: true,
  render: function render(h, context) {
    var messages = context.props.messages;


    return h(DxGroupingPanel, babelHelperVueJsxMergeProps([{
      attrs: {
        layoutComponent: GroupPanelLayout,
        containerComponent: GroupPanelContainer,
        itemComponent: GroupPanelItem,
        emptyMessageComponent: GroupPanelEmptyMessage,
        messages: _extends({}, defaultMessages$1, messages)
      }
    }, { attrs: context.props, on: context.listeners }]));
  },

  components: {
    DxContainer: GroupPanelContainer,
    DxItem: GroupPanelItem,
    DxEmptyMessage: GroupPanelEmptyMessage
  }
};

var ENTER_KEY_CODE$2 = 13;
var SPACE_KEY_CODE$2 = 32;

var handleMouseDown = function handleMouseDown(e) {
  e.target.style.outline = 'none';
};
var handleBlur = function handleBlur(e) {
  e.target.style.outline = '';
};

var ExpandButton = {
  props: {
    visible: {
      type: Boolean,
      default: true
    },
    expanded: {
      type: Boolean
    }
  },
  render: function render() {
    var _this = this;

    var h = arguments[0];
    var expanded = this.expanded,
        visible = this.visible;

    var fireToggle = function fireToggle() {
      if (!visible) return;
      _this.$emit('toggle', !expanded);
    };
    var handleClick = function handleClick(e) {
      e.stopPropagation();
      fireToggle();
    };
    var handleKeyDown = function handleKeyDown(e) {
      if (e.keyCode === ENTER_KEY_CODE$2 || e.keyCode === SPACE_KEY_CODE$2) {
        e.preventDefault();
        fireToggle();
      }
    };
    return h('i', {
      'class': {
        'oi p-2 text-center dx-g-bs4-toggle-button': true,
        'oi-chevron-bottom': expanded,
        'oi-chevron-right': !expanded,
        'dx-g-bs4-toggle-button-hidden': !visible
      }
      // eslint-disable-next-line jsx-a11y/no-noninteractive-tabindex
      , attrs: { tabIndex: visible ? 0 : undefined
      },
      on: {
        'keydown': handleKeyDown,
        'mousedown': handleMouseDown,
        'blur': handleBlur,
        'click': handleClick
      }
    });
  }
};

var TableGroupCell = {
  props: {
    colSpan: {
      type: Number
    },
    row: null,
    column: {
      type: Object
    },
    expanded: {
      type: Boolean
    },
    tableRow: {
      type: Object
    },
    tableColumn: {
      type: Object
    }
  },
  render: function render() {
    var _this = this;

    var h = arguments[0];
    var colSpan = this.colSpan,
        expanded = this.expanded,
        column = this.column,
        row = this.row;

    var handleClick = function handleClick() {
      return _this.$emit('toggle');
    };
    return h(
      'td',
      {
        attrs: {
          colSpan: colSpan
        },
        'class': 'dx-g-bs4-cursor-pointer',
        on: {
          'click': handleClick
        }
      },
      [h(ExpandButton, {
        attrs: {
          expanded: expanded
        },
        on: {
          'toggle': handleClick
        },

        'class': 'mr-2'
      }), h('strong', [column.title || column.name, ': ']), this.$slots.default || row.value]
    );
  }
};

var DxTableGroupRow$1 = {
  name: 'DxTableGroupRow',
  functional: true,
  render: function render(h, context) {
    return h(DxTableGroupRow, babelHelperVueJsxMergeProps([{
      attrs: {
        cellComponent: TableGroupCell,
        rowComponent: TableRow,
        indentColumnWidth: 48
      }
    }, { attrs: context.props, on: context.listeners }]));
  },

  components: {
    DxRow: TableRow,
    DxCell: TableGroupCell
  }
};

var SearchPanelInput = {
  name: 'SearchPanelInput',
  props: {
    value: {
      type: [Number, String],
      default: null
    },
    getMessage: {
      type: Function,
      required: true
    }
  },
  render: function render() {
    var h = arguments[0];
    var value = this.value,
        getMessage = this.getMessage;
    var onValueChange = this.$listeners.valueChange;

    return h("input", {
      attrs: {
        type: "text",

        placeholder: getMessage('searchPlaceholder')
      },
      "class": "form-control w-25",
      on: {
        "input": function input(e) {
          return onValueChange(e.target.value);
        }
      },
      domProps: {
        "value": value
      }
    });
  }
};

var defaultMessages$2 = {
  searchPlaceholder: 'Search...'
};

var DxSearchPanel$1 = {
  name: 'DxSearchPanel',
  functional: true,
  render: function render(h, context) {
    return h(DxSearchPanel, babelHelperVueJsxMergeProps([{
      attrs: {
        inputComponent: SearchPanelInput,
        messages: _extends({}, defaultMessages$2, context.messages)
      }
    }, { attrs: context.props, on: context.listeners }]));
  },

  components: {
    DxInput: SearchPanelInput
  }
};

var SelectionControl = {
  props: {
    disabled: {
      type: Boolean
    },
    checked: {
      type: Boolean
    },
    indeterminate: {
      type: Boolean
    }
  },
  updated: function updated() {
    this.applyIndeterminate();
  },
  mounted: function mounted() {
    this.applyIndeterminate();
  },

  methods: {
    applyIndeterminate: function applyIndeterminate() {
      this.$refs['selection-control-ref'].indeterminate = this.indeterminate;
    }
  },
  render: function render() {
    var h = arguments[0];
    var disabled = this.disabled,
        checked = this.checked;
    var onChange = this.$listeners.change;

    return h('input', {
      'class': {
        'd-inline-block': true,
        'dx-g-bs4-cursor-pointer': !disabled
      },
      attrs: { type: 'checkbox',
        disabled: disabled
      },
      domProps: {
        'checked': checked
      },

      ref: 'selection-control-ref',
      on: {
        'change': function change() {
          if (disabled) return;
          onChange();
        },
        'click': function click(e) {
          return e.stopPropagation();
        }
      }
    });
  }
};

var TableSelectAllCell = {
  props: {
    allSelected: {
      type: Boolean,
      default: false
    },
    someSelected: {
      type: Boolean,
      default: false
    },
    disabled: {
      type: Boolean,
      default: false
    },
    rowSpan: {
      type: Number
    },
    tableColumn: {
      type: Object
    },
    tableRow: {
      type: Object
    }
  },
  render: function render() {
    var h = arguments[0];
    var rowSpan = this.rowSpan,
        disabled = this.disabled,
        allSelected = this.allSelected,
        someSelected = this.someSelected;
    var onToggle = this.$listeners.toggle;

    return h(
      'th',
      {
        'class': {
          'text-center': true,
          'align-middle': !rowSpan,
          'align-bottom': !!rowSpan
        },
        attrs: { rowSpan: rowSpan
        }
      },
      [h(SelectionControl, {
        attrs: {
          disabled: disabled,
          checked: allSelected,
          indeterminate: someSelected
        },
        on: {
          'change': onToggle
        }
      })]
    );
  }
};

var TableSelectCell = {
  props: {
    selected: {
      type: Boolean,
      default: false
    },
    row: null,
    tableRow: {
      type: Object
    },
    tableColumn: {
      type: Object
    }
  },
  render: function render() {
    var h = arguments[0];
    var onToggle = this.$listeners.toggle;
    var selected = this.selected;

    return h(
      "td",
      {
        "class": "text-center align-middle"
      },
      [h(SelectionControl, {
        attrs: {
          checked: selected
        },
        on: {
          "change": onToggle
        }
      })]
    );
  }
};

var TableSelectRow = {
  props: {
    selected: {
      type: Boolean
    },
    selectByRowClick: {
      type: Boolean
    }
  },
  render: function render() {
    var h = arguments[0];
    var selected = this.selected,
        selectByRowClick = this.selectByRowClick;
    var onToggle = this.$listeners.toggle;

    return h(
      'tr',
      {
        'class': selected ? 'table-active' : '',
        on: {
          'click': function click(e) {
            if (!selectByRowClick) return;
            e.stopPropagation();
            onToggle();
          }
        }
      },
      [this.$slots.default]
    );
  }
};

var DxTableSelection$1 = {
  name: 'DxTableSelection',
  functional: true,
  render: function render(h, context) {
    return h(DxTableSelection, babelHelperVueJsxMergeProps([{
      attrs: {
        rowComponent: TableSelectRow,
        cellComponent: TableSelectCell,
        headerCellComponent: TableSelectAllCell,
        selectionColumnWidth: 40
      }
    }, { attrs: context.props, on: context.listeners }]));
  },

  components: {
    DxCell: TableSelectCell,
    DxHeaderCell: TableSelectAllCell
  }
};

var PageSizeSelector = {
  props: {
    pageSize: {
      type: Number,
      required: true
    },
    pageSizes: {
      type: Array,
      required: true
    },
    getMessage: {
      type: Function,
      required: true
    }
  },
  render: function render() {
    var h = arguments[0];
    var pageSize = this.pageSize,
        pageSizes = this.pageSizes,
        getMessage = this.getMessage;
    var pageSizeChange = this.$listeners.pageSizeChange;

    var showAll = getMessage('showAll');

    return h(
      "div",
      { "class": "d-inline-block" },
      [h(
        "select",
        {
          "class": "form-control d-sm-none",
          domProps: {
            "value": pageSize
          },
          on: {
            "change": function change(e) {
              pageSizeChange(parseInt(e.target.value, 10));
            }
          }
        },
        [pageSizes.map(function (val) {
          return h(
            "option",
            { key: val, domProps: {
                "value": val
              }
            },
            [val || showAll]
          );
        })]
      ), h(
        "ul",
        { "class": "pagination d-none d-sm-flex m-0" },
        [pageSizes.map(function (item) {
          return h(
            "li",
            {
              "class": {
                'page-item': true,
                active: item === pageSize
              }
            },
            [h(
              "a",
              {
                "class": "page-link",
                attrs: { href: "#"
                },
                on: {
                  "click": function click(e) {
                    e.preventDefault();
                    pageSizeChange(item);
                  }
                }
              },
              [item || showAll]
            )]
          );
        })]
      )]
    );
  }
};

var PageButtons = {
  name: 'pageButtons',
  functional: true,
  props: {
    currentPage: {
      type: Number,
      required: true
    },
    totalPageCount: {
      type: Number,
      required: true
    },
    currentPageChange: {
      type: Function,
      required: true
    }
  },
  render: function render(h, context) {
    var _context$props = context.props,
        totalPageCount = _context$props.totalPageCount,
        currentPage = _context$props.currentPage,
        currentPageChange = _context$props.currentPageChange;


    var pageButtons = [];
    var maxButtonCount = 3;
    var startPage = 1;
    var endPage = totalPageCount || 1;

    if (maxButtonCount < totalPageCount) {
      startPage = calculateStartPage(currentPage + 1, maxButtonCount, totalPageCount);
      endPage = startPage + maxButtonCount - 1;
    }
    if (startPage > 1) {
      pageButtons.push(h(
        'li',
        { 'class': 'page-item', key: 1 },
        [h(
          'a',
          {
            'class': 'page-link',
            attrs: { href: '#'
            },
            on: {
              'click': function click(e) {
                return currentPageChange(e, 0);
              }
            }
          },
          [1]
        )]
      ));

      if (startPage > 2) {
        pageButtons.push(h(
          'li',
          { 'class': 'page-item disabled', key: 'ellipsisStart', attrs: { disabled: true }
          },
          [h(
            'a',
            { 'class': 'page-link' },
            ['...']
          )]
        ));
      }
    }

    var _loop = function _loop(page) {
      pageButtons.push(h(
        'li',
        {
          key: page,
          'class': {
            'page-item': true,
            active: page === currentPage + 1,
            disabled: startPage === endPage
          }
        },
        [h(
          'a',
          {
            'class': 'page-link',
            attrs: { href: '#'
            },
            on: {
              'click': function click(e) {
                return currentPageChange(e, page - 1);
              }
            }
          },
          [page]
        )]
      ));
    };

    for (var page = startPage; page <= endPage; page += 1) {
      _loop(page);
    }

    if (endPage < totalPageCount) {
      if (endPage < totalPageCount - 1) {
        pageButtons.push(h(
          'li',
          { 'class': 'page-item disabled', key: 'ellipsisEnd', attrs: { disabled: true }
          },
          [h(
            'a',
            { 'class': 'page-link' },
            ['...']
          )]
        ));
      }

      pageButtons.push(h(
        'li',
        { 'class': 'page-item', key: totalPageCount },
        [h(
          'a',
          {
            'class': 'page-link',
            attrs: { href: '#'
            },
            on: {
              'click': function click(e) {
                return currentPageChange(e, totalPageCount - 1);
              }
            }
          },
          [totalPageCount]
        )]
      ));
    }

    return pageButtons;
  }
};

var Pagination = {
  props: {
    totalPages: {
      type: Number,
      required: true
    },
    currentPage: {
      type: Number,
      required: true
    },
    totalCount: {
      type: Number,
      required: true
    },
    pageSize: {
      type: Number,
      required: true
    },
    getMessage: {
      type: Function,
      required: true
    }
  },
  render: function render() {
    var h = arguments[0];
    var totalPages = this.totalPages,
        currentPage = this.currentPage,
        totalCount = this.totalCount,
        pageSize = this.pageSize,
        getMessage = this.getMessage;
    var onCurrentPageChange = this.$listeners.currentPageChange;


    var from = firstRowOnPage(currentPage, pageSize, totalCount);
    var to = lastRowOnPage(currentPage, pageSize, totalCount);
    var currentPageChange = function currentPageChange(e, nextPage) {
      e.preventDefault();
      onCurrentPageChange(nextPage);
    };

    return h(
      'div',
      { 'class': 'd-inline-block float-right' },
      [h(
        'ul',
        { 'class': 'pagination float-right d-none d-sm-flex m-0' },
        [h(
          'li',
          { 'class': {
              'page-item': true,
              disabled: currentPage === 0
            } },
          [h(
            'a',
            {
              'class': 'page-link',
              attrs: { 'aria-label': 'Previous',
                href: '#'
              },
              on: {
                'click': function click(e) {
                  return currentPageChange(e, currentPage - 1);
                }
              }
            },
            [h(
              'span',
              {
                attrs: { 'aria-hidden': 'true' }
              },
              ['\xAB']
            )]
          )]
        ), h(PageButtons, {
          attrs: {
            currentPage: currentPage,
            totalPageCount: totalPages,
            currentPageChange: currentPageChange
          }
        }), h(
          'li',
          { 'class': {
              'page-item': true,
              disabled: currentPage === totalPages - 1 || totalCount === 0
            } },
          [h(
            'a',
            {
              'class': 'page-link',
              attrs: { 'aria-label': 'Next',
                href: '#'
              },
              on: {
                'click': function click(e) {
                  return currentPageChange(e, currentPage + 1);
                }
              }
            },
            [h(
              'span',
              {
                attrs: { 'aria-hidden': 'true' }
              },
              ['\xBB']
            )]
          )]
        )]
      ), h(
        'ul',
        { 'class': 'pagination float-right d-sm-none m-0' },
        [h(
          'li',
          { 'class': {
              'page-item': true,
              disabled: currentPage === 0
            }
          },
          [h(
            'a',
            {
              'class': 'page-link',
              attrs: { 'aria-label': 'Previous',
                href: '#'
              },
              on: {
                'click': function click(e) {
                  return currentPageChange(e, currentPage - 1);
                }
              }
            },
            [h(
              'span',
              {
                attrs: { 'aria-hidden': 'true' }
              },
              ['\xAB']
            )]
          )]
        ), '\xA0', h(
          'li',
          { 'class': {
              'page-item': true,
              disabled: currentPage === totalPages - 1 || totalCount === 0
            }
          },
          [h(
            'a',
            {
              'class': 'page-link',
              attrs: { 'aria-label': 'Next',
                href: '#'
              },
              on: {
                'click': function click(e) {
                  return currentPageChange(e, currentPage + 1);
                }
              }
            },
            [h(
              'span',
              {
                attrs: { 'aria-hidden': 'true' }
              },
              ['\xBB']
            )]
          )]
        )]
      ), h(
        'span',
        { 'class': 'float-right d-sm-none mr-4' },
        [h(
          'span',
          { 'class': 'd-inline-block align-middle' },
          [getMessage('info', { from: from, to: to, count: totalCount })]
        )]
      )]
    );
  }
};

var Pager = {
  props: {
    currentPage: {
      type: Number,
      required: true
    },
    totalPages: {
      type: Number,
      required: true
    },
    pageSize: {
      type: Number,
      required: true
    },
    pageSizes: {
      type: Array,
      required: true
    },
    totalCount: {
      type: Number,
      required: true
    },
    getMessage: {
      type: Function,
      required: true
    }
  },
  render: function render() {
    var h = arguments[0];
    var currentPage = this.currentPage,
        totalPages = this.totalPages,
        pageSize = this.pageSize,
        pageSizes = this.pageSizes,
        totalCount = this.totalCount,
        getMessage = this.getMessage;
    var _$listeners = this.$listeners,
        pageSizeChange = _$listeners.pageSizeChange,
        _currentPageChange = _$listeners.currentPageChange;


    return h(
      'div',
      babelHelperVueJsxMergeProps([{
        'class': 'clearfix card-footer'
      }, this.$attrs]),
      [!!pageSizes.length && h(PageSizeSelector, {
        attrs: {
          pageSize: pageSize,

          pageSizes: pageSizes,
          getMessage: getMessage
        },
        on: {
          'pageSizeChange': pageSizeChange
        }
      }), h(Pagination, {
        attrs: {
          totalPages: totalPages,
          totalCount: totalCount,
          currentPage: currentPage,

          pageSize: pageSize,
          getMessage: getMessage
        },
        on: {
          'currentPageChange': function currentPageChange(page) {
            return _currentPageChange(page);
          }
        }
      })]
    );
  }
};

var defaultMessages$3 = {
  showAll: 'All',
  info: function info(_ref) {
    var from = _ref.from,
        to = _ref.to,
        count = _ref.count;
    return '' + from + (from < to ? '-' + to : '') + ' of ' + count;
  }
};

var DxPagingPanel$1 = {
  name: 'DxPagingPanel',
  functional: true,
  render: function render(h, context) {
    var messages = context.props.messages;

    return h(DxPagingPanel, babelHelperVueJsxMergeProps([{
      attrs: {
        containerComponent: Pager,
        messages: _extends({}, defaultMessages$3, messages)
      }
    }, { attrs: context.props, on: context.listeners }]));
  },

  components: {
    DxContainer: Pager
  }
};

var CommandButton = {
  props: {
    text: {
      type: String,
      required: true
    }
  },
  render: function render() {
    var _this = this;

    var h = arguments[0];

    return h(
      "button",
      {
        "class": "btn btn-link dx-g-bs4-table-edit-command-cell",
        on: {
          "click": function click() {
            _this.$emit('execute');
          }
        }
      },
      [this.text]
    );
  }
};

var EditCommandHeadingCell = {
  props: {
    tableColumn: {
      type: Object
    },
    tableRow: {
      type: Object
    }
  },
  render: function render() {
    var h = arguments[0];

    return h(
      "th",
      {
        "class": "text-center p-0 text-nowrap"
      },
      [this.$slots.default]
    );
  }
};

var EditCommandCell = {
  props: {
    row: null,
    tableRow: {
      type: Object
    },
    tableColumn: {
      type: Object
    }
  },
  render: function render() {
    var h = arguments[0];

    return h(
      "td",
      {
        "class": "text-center p-0 text-nowrap"
      },
      [this.$slots.default]
    );
  }
};

var defaultMessages$4 = {
  addCommand: 'New',
  editCommand: 'Edit',
  deleteCommand: 'Delete',
  commitCommand: 'Save',
  cancelCommand: 'Cancel'
};

var DxTableEditColumn$1 = {
  name: 'DxTableEditColumn',
  functional: true,
  render: function render(h, context) {
    return h(DxTableEditColumn, babelHelperVueJsxMergeProps([{
      attrs: {
        cellComponent: EditCommandCell,
        headerCellComponent: EditCommandHeadingCell,
        commandComponent: CommandButton,
        messages: _extends({}, defaultMessages$4, context.messages)
      }
    }, { attrs: context.props, on: context.listeners }]));
  },

  components: {
    DxCommand: CommandButton,
    DxCell: EditCommandCell,
    DxHeaderCell: EditCommandHeadingCell
  }
};

var EditCell = {
  props: {
    tableRow: {
      type: Object
    },
    column: {
      type: Object
    },
    row: null,
    tableColumn: {
      type: Object
    },
    value: null,
    editingEnabled: {
      type: Boolean,
      default: true
    }
  },
  render: function render() {
    var _this = this;

    var h = arguments[0];
    var value = this.value,
        editingEnabled = this.editingEnabled,
        tableColumn = this.tableColumn;

    return h(
      "td",
      { "class": "align-middle dx-g-bs4-table-edit-cell" },
      [this.$slots.default || h("input", {
        attrs: {
          type: "text",

          readOnly: !editingEnabled
        },
        "class": {
          'form-control w-100': true,
          'text-right': tableColumn && tableColumn.align === 'right',
          'text-center': tableColumn && tableColumn.align === 'center'
        }, domProps: {
          "value": value
        },
        on: {
          "change": function change(e) {
            return _this.$emit('valueChange', e.target.value);
          }
        }
      })]
    );
  }
};

var DxTableEditRow$1 = {
  name: 'DxTableEditRow',
  functional: true,
  render: function render(h, context) {
    return h(DxTableEditRow, babelHelperVueJsxMergeProps([{
      attrs: {
        cellComponent: EditCell,
        rowComponent: TableRow
      }
    }, { attrs: context.props, on: context.listeners }]));
  },

  components: {
    DxCell: EditCell,
    DxRow: TableRow
  }
};

var TableDetailToggleCell = {
  props: {
    expanded: {
      type: Boolean
    }
  },
  render: function render() {
    var _this = this;

    var h = arguments[0];

    var toggle = function toggle() {
      return _this.$emit('toggle');
    };
    return h(
      'td',
      {
        'class': 'text-center align-middle'
      },
      [h(ExpandButton, {
        attrs: {
          expanded: this.expanded
        },
        on: {
          'toggle': toggle
        }
      })]
    );
  }
};

var TableDetailCell = {
  props: {
    colSpan: {
      type: Number
    }
  },
  render: function render() {
    var h = arguments[0];

    return h(
      "td",
      {
        attrs: {
          colSpan: this.colSpan
        },
        "class": "table-active"
      },
      [this.$slots.default]
    );
  }
};

var DxTableRowDetail$1 = {
  name: 'DxTableRowDetail',
  functional: true,
  render: function render(h, context) {
    return h(DxTableRowDetail, babelHelperVueJsxMergeProps([{
      attrs: {
        toggleCellComponent: TableDetailToggleCell,
        cellComponent: TableDetailCell,
        rowComponent: TableRow,
        toggleColumnWidth: 48
      }
    }, { attrs: context.props, on: context.listeners }]));
  },

  components: {
    DxCell: TableDetailCell,
    DxToggleCell: TableDetailToggleCell,
    DxRow: TableRow
  }
};

export { DxGrid$1 as DxGrid, DxTable$1 as DxTable, DxTableHeaderRow$1 as DxTableHeaderRow, DxTableFilterRow$1 as DxTableFilterRow, DxToolbar$1 as DxToolbar, DxGroupingPanel$1 as DxGroupingPanel, DxTableGroupRow$1 as DxTableGroupRow, DxSearchPanel$1 as DxSearchPanel, DxTableSelection$1 as DxTableSelection, DxPagingPanel$1 as DxPagingPanel, DxTableEditColumn$1 as DxTableEditColumn, DxTableEditRow$1 as DxTableEditRow, DxTableRowDetail$1 as DxTableRowDetail };
//# sourceMappingURL=dx-vue-grid-bootstrap4.es.js.map
